package organization;

/**
 * This is an interface for the visitor on employees
 * This interface offers a chance to visit every kind of concrete employee in
 * the hierarchy. Some visitors may want this level of granularity, others
 * may not
 * @param <R> the type of the return parameter for the visit
 */
public interface EmployeeVisitor<R> {
  R visitContractEmployee(ContractEmployee e);
  R visitInternalEmployee(InternalEmployee e);
  R visitNonManagerEmployee(NonManagerEmployee e);
  R visitSupervisor(Supervisor e);
}
