package organization;

import java.util.ArrayList;
import java.util.List;

import util.Gender;

/**
 * This class  represents an employee that does not have any managerial
 * responsibilities.
 */

public class NonManagerEmployee extends GenericEmployee{
  public NonManagerEmployee(String name, double pay, Gender gender) {
    super(name, pay, gender);
  }

  @Override
  public Employee addSupervisee(String supervisorName,Employee supervisee) {
    if (this.name.equals(supervisorName)) {
      //must first "promote" this employee
      Supervisor newSelf = new Supervisor(this.name,this.pay,this
              .gender);
      newSelf.addSupervisee(supervisorName,supervisee);
      return newSelf;
    }
    return this;
  }

  @Override
  public <R> R accept(EmployeeVisitor<R> visitor) {
    return visitor.visitNonManagerEmployee(this);
  }
}
